System.register(["__unresolved_0", "cc", "tools-cocos38", "__unresolved_1"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, __checkObsolete__, __checkObsoleteInNamespace__, _cc, fgui, ResLoadEnum, Res, _crd, cc;

  function _reportPossibleCrUseOfResLoadEnum(extras) {
    _reporterNs.report("ResLoadEnum", "../enum/Enum", _context.meta, extras);
  }

  function _reportPossibleCrUseOfRouterTag(extras) {
    _reporterNs.report("RouterTag", "../enum/Enum", _context.meta, extras);
  }

  _export("default", void 0);

  return {
    setters: [function (_unresolved_) {
      _reporterNs = _unresolved_;
    }, function (_cc2) {
      _cclegacy = _cc2.cclegacy;
      __checkObsolete__ = _cc2.__checkObsolete__;
      __checkObsoleteInNamespace__ = _cc2.__checkObsoleteInNamespace__;
      _cc = _cc2;
    }, function (_toolsCocos) {
      fgui = _toolsCocos;
    }, function (_unresolved_2) {
      ResLoadEnum = _unresolved_2.ResLoadEnum;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "1567d6q/rFKLKw/1uTKHa1D", "Res", undefined);

      cc = __checkObsoleteInNamespace__(_cc);

      /**
       * Resource loading tool
       */
      _export("default", Res = class Res {
        constructor() {
          this.progress = 0;
          //Current loading progress
          this.dirs = ['fgui', 'sound', 'spine', 'json', 'map', 'font', 'prefab', 'img'];

          //List of currently loaded resources
          this.callback = () => {};

          //Call back after loading
          this.bundle = null;
          this.bundleName = null;
          this.setArr = [];
          this.loadTime = 0;
        }

        /**
         *  Load resources
         * @param bundleName
         * @param callback -Call back after loading
         * @param dirs - Load a list of resources（['img','sound','map'],['img/banner','sound/click','map/level1']）
         * @param isDir - Whether to load directory, defaults to true, and passes false when loading individual files
         * @param updateBundle - Append load bundle
         */
        load(bundleName, callback) {
          this.bundleName = bundleName;
          this.callback = callback;
          this.progress = 0;
          this.bundle = Res.bundleMap.get(bundleName);

          if (!this.bundle) {
            cc.assetManager.loadBundle(bundleName, (err, bundle) => {
              this.bundle = bundle;
              Res.bundleMap.set(bundleName, bundle);
              this.loadDirsLength();
              this.loadRes();
            });
          } else {
            this.loadDirsLength();
            this.loadRes();
          }
        }

        /**
         * The total length of the loaded folder or file resource
         */
        loadDirsLength() {
          this.setArr = [];

          for (let i = 0; i < this.dirs.length; i++) {
            let list = [];
            this.bundle.getDirWithPath(this.dirs[i], cc.Asset, this.setArr);

            for (let i = 0; i < list.length; i++) {
              this.setArr.push(list[i]);
            }
          }
        }

        /**
         * Load a folder or file resource
         */
        loadRes() {
          this.emitProgress();
          this.loadTime = 0;
          this.setArr.forEach(el => {
            let t = new Date().getTime();
            this.bundle.load(el.path, cc.Asset, null, (err, asset) => {
              let t2 = new Date().getTime() - t;
              this.loadTime += t2 / 1000;
              this.progress += 1;
              this.updateProgress();
            });
          });
        }
        /**
         * 将当前加载进度进行广播
         */


        emitProgress() {
          const _obj = {
            progress: this.progress / this.setArr.length,
            total: this.setArr.length,
            num: this.progress,
            bundleName: this.bundleName
          };
          CEvent.emit((_crd && ResLoadEnum === void 0 ? (_reportPossibleCrUseOfResLoadEnum({
            error: Error()
          }), ResLoadEnum) : ResLoadEnum).loadProgress, _obj);
        }
        /**
         *  Update loading progress
         */


        updateProgress() {
          this.emitProgress();

          if (this.progress >= this.setArr.length) {
            // console.log('Resource loading time', this.loadTime)
            this.callback(this.bundle);
          }
        }

        /**
         * Get the file based on the resource name type
         * It is used to distinguish files with the same name in spine
         * 
            Res.loadFile(HomeScript.Tag,"spine/Demon",sp.SkeletonData,(assets:sp.SkeletonData)=>{
                console.log(assets);
            })
         * 
         */
        static loadFile(bundleName, url, type, callback) {
          Res.bundleMap.get(bundleName).load(url, type, (error, assets) => {
            if (callback) callback(assets);
          });
        }
        /**
         *  get resources
         *  Res.getAsset(`Res`,`image/tmx/map1`) It's a map file. Full name map1.tmx
         * @param bundleName
         * @param assetUrl
         * @returns
         */


        static getAsset(bundleName, assetUrl, type = cc.Asset) {
          let tempAsset = Res.bundleMap.get(bundleName).get(assetUrl, type);
          return tempAsset;
        }
        /**
         * Load resources for other scenarios
         * @param tag
         * @returns
         * @example
         * let homeRes:Res = Res.loadRes(HomeScript.Tag)
         */


        static loadRes(tag, callback) {
          let resT = new Res();
          resT.load(tag, bundle => {
            if (callback) callback();
          });
          return resT;
        }

        static loadPackage(bundle) {
          return new Promise(res => {
            fgui.UIPackage.loadPackage(bundle, 'fgui/' + bundle.name, (err, pkg) => {
              res(true);
            });
          });
        }
        /**
         * Load resources for other scenarios asyc
         * @param tag
         * @returns
         * @example
         * let homeRes:Res = Res.loadRes(HomeScript.Tag)
         */


        static loadResAsyc(tag, callback) {
          const that = Res;
          return new Promise(_res => {
            let resT = new Res();
            resT.load(tag, async bundle => {
              await that.loadPackage(bundle);
              if (callback) callback();

              _res(resT);
            });
          });
        }
        /**
         * 注册加载多个bundle的进度回调统计
         * @param names
         * @example
         * CEvent.on(ResLoadEnum.loadProgressArr, (data:ResProgress)=>{})
         * Res.onProgress('common','login','home')
         * Res.loadRes(RouterTag.common)
         * Res.loadRes(RouterTag.login)
         * Res.loadRes(RouterTag.home)
         */


        static onProgress(names) {
          let loadObj = {};
          let loadResult = {
            progress: 0,
            total: 100,
            num: 0
          };

          const getLoadProgress = () => {
            const _loadResult = {
              total: 0,
              num: 0
            };

            const _keys = Object.keys(loadObj);

            _keys.map(key => {
              return loadObj[key];
            }).forEach(item => {
              _loadResult.total += item.total;
              _loadResult.num += item.num;
            });

            if (_keys.length === names.length) {
              loadResult.total = _loadResult.total;
            }

            loadResult.num = _loadResult.num;
            loadResult.progress = _loadResult.num / _loadResult.total;
            CEvent.emit((_crd && ResLoadEnum === void 0 ? (_reportPossibleCrUseOfResLoadEnum({
              error: Error()
            }), ResLoadEnum) : ResLoadEnum).loadProgressArr, loadResult);

            if (_loadResult.num >= _loadResult.total) {
              CEvent.off(cid);
            }
          };

          const cid = CEvent.on((_crd && ResLoadEnum === void 0 ? (_reportPossibleCrUseOfResLoadEnum({
            error: Error()
          }), ResLoadEnum) : ResLoadEnum).loadProgress, data => {
            loadObj[data.bundleName] = data;
            getLoadProgress();
            console.log('loadResult', loadResult);
          });
        }

      });

      Res.bundleMap = new Map();

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=17c50bf6681260622ecbe69dd32ac8271e261d0d.js.map