System.register(["cc"], function (_export, _context) {
  "use strict";

  var _cclegacy, __checkObsolete__, __checkObsoleteInNamespace__, Input, KeyCode, input, CKeyUtil, _crd, Key_EventType;

  _export("CKeyUtil", void 0);

  return {
    setters: [function (_cc) {
      _cclegacy = _cc.cclegacy;
      __checkObsolete__ = _cc.__checkObsolete__;
      __checkObsoleteInNamespace__ = _cc.__checkObsoleteInNamespace__;
      Input = _cc.Input;
      KeyCode = _cc.KeyCode;
      input = _cc.input;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "44ec8907bBNRrlSKnMC/T1Q", "CKeyUtil", undefined);

      __checkObsolete__(['Input', 'KeyCode', 'input']);

      Key_EventType = /*#__PURE__*/function (Key_EventType) {
        Key_EventType["KEY_DOWN"] = "KEY_DOWN";
        Key_EventType["KEY_UP"] = "KEY_UP";
        return Key_EventType;
      }(Key_EventType || {});

      /**
       * 按键监听工具，用于PC端，需要导入tools-javascript库
       */
      _export("CKeyUtil", CKeyUtil = class CKeyUtil {
        /**
         * 注册全局按键事件
         */
        static init() {
          const that = CKeyUtil;

          for (const key in KeyCode) {
            const _content = KeyCode[key];

            if (typeof _content !== 'string') {
              that.keyMap[_content] = {
                keyName: key,
                keyCode: _content
              };
            }
          }

          input.on(Input.EventType.KEY_DOWN, e => {
            const _key = that.keyMap[e.keyCode].keyName;
            CEvent.emit(Key_EventType.KEY_DOWN, {
              key: _key
            });
          });
          input.on(Input.EventType.KEY_UP, e => {
            const _key = that.keyMap[e.keyCode].keyName;
            CEvent.emit(Key_EventType.KEY_UP, {
              key: _key
            });
          });
        }
        /**
         * 监听组合键
         * @param keys 组合键数组
         * @param callback 触发回调函数
         * @example
         * //Ctrl+Q
         * CKeyUtil.on(['Ctrl','Q'],()=>{
         *  console.log('成功')
         * })
         * @returns
         */


        static on(keys, callback) {
          let downKey = {};

          const keydown = function (event) {
            const _key = event.key;
            if (downKey[_key]) return;
            downKey[_key] = true;
            const endKey = keys[keys.length - 1] === _key;
            let allDown = true;

            for (let i = 0; i < keys.length - 1; i++) {
              if (!downKey[keys[i]]) {
                allDown = false;
                break;
              }
            }

            if (endKey && allDown) {
              callback();
            }
          };

          const keyup = function (event) {
            const _key = event.key;
            downKey[_key] = false;
          };

          const did = CEvent.on(Key_EventType.KEY_DOWN, e => {
            keydown(e);
          });
          const uid = CEvent.on(Key_EventType.KEY_UP, e => {
            keyup(e);
          });
          return () => {
            CEvent.off(did, uid);
          };
        }

      });

      CKeyUtil.keyMap = {};

      /**
       * 管理器
       */
      CKeyUtil.eventMap = {};

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=2f923feb75e7f5ec4b083850b4c8daf3b93fd1b4.js.map