System.register(["cc"], function (_export, _context) {
  "use strict";

  var _cclegacy, __checkObsolete__, __checkObsoleteInNamespace__, _cc, CKeyUtil, _crd, cc, Key_EventType;

  _export("default", void 0);

  return {
    setters: [function (_cc2) {
      _cclegacy = _cc2.cclegacy;
      __checkObsolete__ = _cc2.__checkObsolete__;
      __checkObsoleteInNamespace__ = _cc2.__checkObsoleteInNamespace__;
      _cc = _cc2;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "ad536n0MzhKpK4niifeV6XO", "CKeyUtil", undefined);

      cc = __checkObsoleteInNamespace__(_cc);

      Key_EventType = /*#__PURE__*/function (Key_EventType) {
        Key_EventType["KEY_DOWN"] = "KEY_DOWN";
        Key_EventType["KEY_UP"] = "KEY_UP";
        return Key_EventType;
      }(Key_EventType || {});

      _export("default", CKeyUtil = class CKeyUtil {
        /**
         * 注册全局按键事件
         */
        static init() {
          const that = CKeyUtil;

          for (const key in cc.KeyCode) {
            const _content = cc.KeyCode[key];

            if (typeof _content !== 'string') {
              that.keyMap[_content] = {
                keyName: key,
                keyCode: _content
              };
            }
          }

          cc.input.on(cc.Input.EventType.KEY_DOWN, e => {
            const _key = that.keyMap[e.keyCode].keyName;
            CEvent.emit(Key_EventType.KEY_DOWN, {
              key: _key
            });
          });
          cc.input.on(cc.Input.EventType.KEY_UP, e => {
            const _key = that.keyMap[e.keyCode].keyName;
            CEvent.emit(Key_EventType.KEY_UP, {
              key: _key
            });
          });
        }
        /**
         * 监听组合键
         * @param keys 组合键数组
         * @param callback 触发回调函数
         * @example
         * //Ctrl+Q
         * CKeyUtil.on(['Ctrl','Q'],()=>{
         *  console.log('成功')
         * })
         * @returns
         */


        static on(keys, callback) {
          let downKey = {};

          const keydown = function (event) {
            const _key = event.key;
            if (downKey[_key]) return;
            downKey[_key] = true;
            const endKey = keys[keys.length - 1] === _key;
            let allDown = true;

            for (let i = 0; i < keys.length - 1; i++) {
              if (!downKey[keys[i]]) {
                allDown = false;
                break;
              }
            }

            if (endKey && allDown) {
              callback();
            }
          };

          const keyup = function (event) {
            const _key = event.key;
            downKey[_key] = false;
          };

          const did = CEvent.on(Key_EventType.KEY_DOWN, e => {
            keydown(e);
          });
          const uid = CEvent.on(Key_EventType.KEY_UP, e => {
            keyup(e);
          });
          return () => {
            CEvent.off(did, uid);
          };
        }

      });

      CKeyUtil.keyMap = {};

      /**
       * 管理器
       */
      CKeyUtil.eventMap = {};

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=ae88cc1a6bdf3f5f0d217e1e04a158e74bade054.js.map