System.register(["cc"], function (_export, _context) {
  "use strict";

  var _cclegacy, __checkObsolete__, __checkObsoleteInNamespace__, AudioClip, AudioSource, Node, SoundBean, _crd;

  function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

  function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

  _export("SoundBean", void 0);

  return {
    setters: [function (_cc) {
      _cclegacy = _cc.cclegacy;
      __checkObsolete__ = _cc.__checkObsolete__;
      __checkObsoleteInNamespace__ = _cc.__checkObsoleteInNamespace__;
      AudioClip = _cc.AudioClip;
      AudioSource = _cc.AudioSource;
      Node = _cc.Node;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "69255CRZ15MvI1Q9O+G8tOn", "SoundBean", undefined);

      __checkObsolete__(['AudioClip', 'AudioSource', 'Node']);

      _export("SoundBean", SoundBean = class SoundBean {
        constructor() {
          this.node = null;
          this.audioSource = null;
          this.id = null;
          this.param = null;
        }

        /**
         * 设置配置
         * @param param 参数
         */
        setConfig(param) {
          var _this = this;

          return _asyncToGenerator(function* () {
            _this.param = param;
            var {
              bundleName,
              musicName,
              volume
            } = _this.param;
            _this.id = StrUtil.getId();
            var soundUrl1 = param.dir + musicName;
            var clip = yield param.Res.getAsset(soundUrl1, AudioClip, bundleName);
            _this.node = new Node();
            _this.audioSource = _this.node.addComponent(AudioSource);
            _this.audioSource.playOnAwake = param.autoPlay;

            _this.setClip(clip);

            _this.setVolume(volume);

            _this.audioSource.node.on(AudioSource.EventType.STARTED, _this.onAudioStarted, _this);

            _this.audioSource.node.on(AudioSource.EventType.ENDED, _this.onAudioEnded, _this);
          })();
        }
        /**
         * 播放开始回调
         */


        onAudioStarted() {
          if (this.param.startFun) this.param.startFun();
        }
        /**
         * 播放结束回调
         */


        onAudioEnded() {
          if (this.param.endFun) this.param.endFun();

          if (this.param.loop) {
            this.play();
          }
        }
        /**
         * 播放音频
         */


        play() {
          this.audioSource.play();
        }
        /**
         * 停止音频
         */


        stop() {
          this.audioSource.stop();
        }
        /**
         * 暂停音频
         */


        pause() {
          this.audioSource.pause();
        }
        /**
         * 恢复音频
         */


        resume() {
          this.play();
        }
        /**
         * 设置音频资源
         * @param clip 音频
         */


        setClip(clip) {
          this.audioSource.clip = clip;
        }
        /**
         * 设置音量
         * @param volume 音量
         */


        setVolume(volume) {
          this.audioSource.volume = volume;
        }
        /**
         * 销毁音频
         */


        destroy() {
          this.setVolume(0);
          this.audioSource.node.off(AudioSource.EventType.STARTED, this.onAudioStarted, this);
          this.audioSource.node.off(AudioSource.EventType.ENDED, this.onAudioEnded, this);
          this.node.removeFromParent();
          this.node.destroy();
        }

      });

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=37b94b80641a5ff3b2d1f884c4d2153163bdd713.js.map