System.register(["__unresolved_0", "cc", "__unresolved_1", "__unresolved_2"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, __checkObsolete__, __checkObsoleteInNamespace__, Node, director, ResUtil, SoundBean, Sound, _crd;

  function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

  function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

  function _reportPossibleCrUseOfResUtil(extras) {
    _reporterNs.report("ResUtil", "./Res", _context.meta, extras);
  }

  function _reportPossibleCrUseOfSoundBean(extras) {
    _reporterNs.report("SoundBean", "./SoundBean", _context.meta, extras);
  }

  function _reportPossibleCrUseOfSoundBeanParam(extras) {
    _reporterNs.report("SoundBeanParam", "./SoundBean", _context.meta, extras);
  }

  _export("Sound", void 0);

  return {
    setters: [function (_unresolved_) {
      _reporterNs = _unresolved_;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      __checkObsolete__ = _cc.__checkObsolete__;
      __checkObsoleteInNamespace__ = _cc.__checkObsoleteInNamespace__;
      Node = _cc.Node;
      director = _cc.director;
    }, function (_unresolved_2) {
      ResUtil = _unresolved_2.Res;
    }, function (_unresolved_3) {
      SoundBean = _unresolved_3.SoundBean;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "45759thb8tFpphgF6ym0WZl", "Sound", undefined);

      __checkObsolete__(['Node', 'director']);

      /**
       * 播放音频类
       */
      _export("Sound", Sound = class Sound {
        /**
         * 初始化
         * @param Res 资源管理器
         */
        static init(Res) {
          var that = Sound;
          that.Res = Res || (_crd && ResUtil === void 0 ? (_reportPossibleCrUseOfResUtil({
            error: Error()
          }), ResUtil) : ResUtil);
          that.boundMap = {};
          that.rootNode = new Node();
          that.rootNode.name = '__Sound__' + StrUtil.getId();
          director.getScene().addChild(that.rootNode);
          director.addPersistRootNode(that.rootNode);
        }
        /**
         * 播放音频
         * @param musicName 音频名
         * @param param 参数
         * @returns 音频对象
         */


        static play(musicName, param) {
          return _asyncToGenerator(function* () {
            if (param === void 0) {
              param = {};
            }

            var that = Sound;
            if (param.autoPlay === undefined) param.autoPlay = true;

            var _SoundBean = new (_crd && SoundBean === void 0 ? (_reportPossibleCrUseOfSoundBean({
              error: Error()
            }), SoundBean) : SoundBean)();

            param = that.getParam(musicName, param);
            yield _SoundBean.setConfig(param);

            _SoundBean.setVolume(_SoundBean.param.volume * that.volume);

            that.rootNode.addChild(_SoundBean.node);
            if (param.autoPlay) _SoundBean.play();
            that.boundMap[param.musicName + '-' + param.bundleName] = _SoundBean;
            return _SoundBean;
          })();
        }
        /**
         * 获取参数-外部不使用
         * @param musicName 音频名
         * @param param 参数
         * @returns 参数
         */


        static getParam(musicName, param) {
          var that = Sound;
          param.dir = that.dir;
          param.Res = that.Res;
          return Object.assign({
            musicName,
            bundleName: param.bundleName || param.Res.bundleName,
            loop: false,
            volume: Sound.volume
          }, param);
        }
        /**
         * 获取音频对象-外部不使用，请使用play方法获取音频对象
         * @param musicName 音频名
         * @param param 参数
         * @returns 音频对象
         */


        static getSoundBean(musicName, param) {
          if (param === void 0) {
            param = {};
          }

          var that = Sound;
          param = that.getParam(musicName, param);
          return that.boundMap[param.musicName + '-' + param.bundleName];
        }
        /**
         * 停止音频
         * @param musicName 音频名
         * @param param 参数
         */


        static stop(musicName, param) {
          var _Sound$getSoundBean;

          if (param === void 0) {
            param = {};
          }

          (_Sound$getSoundBean = Sound.getSoundBean(musicName, param)) == null || _Sound$getSoundBean.stop();
        }
        /**
         * 暂停音频
         * @param musicName 音频名
         * @param param 参数
         */


        static pause(musicName, param) {
          var _Sound$getSoundBean2;

          if (param === void 0) {
            param = {};
          }

          (_Sound$getSoundBean2 = Sound.getSoundBean(musicName, param)) == null || _Sound$getSoundBean2.pause();
        }
        /**
         * 恢复音频
         * @param musicName 音频名
         * @param param 参数
         */


        static resume(musicName, param) {
          var _Sound$getSoundBean3;

          if (param === void 0) {
            param = {};
          }

          (_Sound$getSoundBean3 = Sound.getSoundBean(musicName, param)) == null || _Sound$getSoundBean3.resume();
        }
        /**
         * 销毁音乐资源对象
         * @param musicName 音频名
         * @param param 参数
         */


        static destroy(musicName, param) {
          if (param === void 0) {
            param = {};
          }

          var that = Sound;
          param = that.getParam(musicName, param);

          var _key = param.musicName + '-' + param.bundleName;

          var _SoundBean = that.boundMap[_key];

          _SoundBean.destroy();

          that.boundMap[_key] = undefined;
          delete that.boundMap[_key];
        }
        /**
         * 整体调整所有音量大小
         * @param volume 音量大小
         */


        static setVolume(volume) {
          var that = Sound;
          that.volume = volume;
          Object.keys(that.boundMap).forEach(key => {
            var _SoundBean = that.boundMap[key];

            _SoundBean.setVolume(_SoundBean.param.volume * volume);
          });
        }

      });

      /**
       * 音频对象集合
       */
      Sound.boundMap = null;

      /**
       * 音频全局挂载接点
       */
      Sound.rootNode = null;

      /**
       * 全局默认音量大小
       */
      Sound.volume = 1;

      /**
       * 全局默认bundle下的音效路径
       */
      Sound.dir = 'sound/';

      /**
       * 全局默认资源管理器
       */
      Sound.Res = null;

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=488d2f3b2079181c52718d06e3dc4991ef5d1e3d.js.map