System.register(["cc"], function (_export, _context) {
  "use strict";

  var _cclegacy, i18n, _crd;

  function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

  function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

  _export("default", void 0);

  return {
    setters: [function (_cc) {
      _cclegacy = _cc.cclegacy;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "78fdf6LeIFJO73Pvzm/5mhL", "i18n", undefined);

      _export("default", i18n = class i18n {
        /**
         * 注册需要国际化的文本组件
         * @param text
         * @returns
         */
        static on(text, maxLength) {
          if (!text) return;
          var id = StrUtil.getId();
          text.data = {};
          text.data.i18nId = id;
          i18n.textMap[id] = text;

          if (text.data.i18nText === undefined) {
            text.data.i18nText = text.text;
            text.data.maxLength = maxLength;
          }

          i18n.setText(text);
        }
        /**
         * 销毁国际化的文本组件
         * @param text
         * @returns
         */


        static off(text) {
          var id = text.data.i18nId;
          delete i18n.textMap[id];
        }

        static getText(key) {
          var val = i18n.langMap[i18n.lang][key]; // console.log('val', val)

          if (StrUtil.isNull(val)) val = ''; // console.log('val1', val)

          return val;
        }

        static setText(text) {
          var maxLength = text.data.maxLength;

          var _content = i18n.getText(text.data.i18nText + '') + '';

          if (maxLength && _content.length > maxLength) {
            _content = _content.substring(0, maxLength) + '.';
          }

          text.text = _content;
        }
        /**
         * 更新所有文本内容
         */


        static updateAllText() {
          Object.keys(i18n.textMap).forEach(key => {
            var text = i18n.textMap[key];
            i18n.setText(text);
          });
        }
        /**
         * 设置国际化
         * @param lang
         */


        static setLang(lang) {
          return _asyncToGenerator(function* () {
            var _status = yield i18n.loadLang(lang);

            if (_status) {
              i18n.updateAllText();
            }
          })();
        }

        static loadLang(lang) {
          i18n.lang = lang;
          return new Promise( /*#__PURE__*/_asyncToGenerator(function* (res) {
            if (i18n.langMap[lang]) {
              res(i18n.langMap[lang]);
              return;
            }

            try {
              var langStr = yield http.get(i18n.base + lang + i18n.baseend);
              i18n.langMap[lang] = langStr;
              res(i18n.langMap[lang]);
            } catch (error) {
              console.log(error);
              res(false);
            }
          }));
        }

      });

      i18n.base = '';
      i18n.baseend = '.json';
      i18n.lang = '';
      i18n.textMap = {};
      i18n.langMap = {};

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=d5b1d3e1a5e565830307c00206745c620945d4bd.js.map